/**
 * Author Murukesh Sadasivan (murukesh@codeflow.co)
 *
 * Copyright 2016 Codeflow Private Limited
 *
 * MIT Licensed
 */
'use strict'

var icepick = require('icepick')

module.exports.map = function(input, callback, options) {
    callback(null, input)
}

module.exports.assignSchema = function(input, callback, options) {
    callback(null, input.object)
}

module.exports.modifyObject = function(input, callback, options) {
    var out = input.input || {}

    if(input.set && Array.isArray(input.set)) {
        input.set.forEach(({key, value})=>{
            if(!key || key === '') { return }
            out = icepick.assocIn(out, key.split('.'), value)
        })
    }

    if(input.remove && Array.isArray(input.remove)) {
        input.remove.forEach(({key})=>{
            if(!key || key === '') { return }
            out = icepick.assocIn(out, key.split('.'), undefined)
        })
    }

    callback(null, out)
}